﻿using System;

namespace Scripts
{
    //Базовый класс для всех скриптов
    //Предоставляет функционал для взаимодействия скрипта с движком
    public abstract class ScriptingBase
    {
        //событие для отобраджения окна с сообщением
        public static event Action<string> ShowMessageNeeded = delegate { };

        // Этот метод должен переопределяться в наследниках
        // Он будет автоматически вызываться движком игры в каждом фрейме
        public abstract void Update();

        // Метод для показа сообщения в игре
        // Этот метод можно вызывать из скрипта
        protected void ShowMessage(string message)
        {
            ShowMessageNeeded(message);
        }
    }
}
