﻿using System;
using UnityEngine;
using Scripts;
using System.Linq;
using System.IO;
using System.Reflection;

public class PluginsController : MonoBehaviour
{
    ScriptingBase script;

    private void Start()
    {
        //подсовываем свою длл вместо любой другой
        AppDomain.CurrentDomain.AssemblyResolve += (o, e) => Assembly.GetExecutingAssembly();

        //ищем файлы *Addon.dll вокруг себя
        var addonFile = Directory.GetFiles(Path.Combine(Application.dataPath, ".."), "*Addon.dll", SearchOption.AllDirectories).FirstOrDefault();

        //если файл аддона найден
        if (addonFile != null)
        {
            //загружаем длл
            var ass = Assembly.LoadFile(addonFile);

            //ищем все классы, унаследованные от ScriptingBase
            foreach (var type in ass.GetTypes())
            {
                //этот тип унаследован от ScriptingBase?
                if (typeof(ScriptingBase).IsAssignableFrom(type))
                // не абстрактный?
                if (!type.IsAbstract)
                {
                    //создаем экземпляр скрипта
                    script = Activator.CreateInstance(type) as ScriptingBase;
                    break;
                }
            }
        }
    }

    private void Update()
    {
        //обновляем скрипт
        if (script != null)
            script.Update();
    }
}
